C *************************************************************************
C
C			PROGRAM VECTORH
C
C		RANDY WISE	GLENN BOWEN
C
C		          11/10/89  REVISED: RAD--11/16/89
C
C *************************************************************************
C
C	PROGRAM TO PLOT A FIELD OF ARROWS REPRESENTING WAVE HEIGHT AND
C	DIRECTION USING 'ANGLE.DAT' AND 'HEIGHT.DAT', THE OUTPUT FILES
C	FROM 'REFRACT'
c
c       compile with ncargf77 vectorh.f   to get a.out, rename it to vectorh
C
C          print:  ftrans -g ps.mono  gmeta | lpr -Plw
C         screen:  ctrans -d sunview  gmeta
C
        parameter (imax=100,jmax=100)
	DIMENSION U(imax,jmax),V(imax,jmax),H(imax,jmax),THETA(imax,jmax)
	DIMENSION U1(imax,jmax),V1(imax,jmax),U2(imax,jmax)   
        dimension V2(imax,jmax)
	CALL GOPKS(6,IDUM)
	CALL GOPWK(1,2,1)
	CALL GACWK(1)
	RAD=2.*3.14159/360.	
C
C
C	READ DATA FROM 'height.dat' AND 'angle.dat'
C
C
	OPEN(1,FILE='height.dat')
	READ(1,*) M,N,DX,DY
        IF(M.GT.imax.OR.N.GT.jmax) THEN
           WRITE(*,*) ' RESIZE VECTORH; ARRAYS TOO LARGE'
           GO TO 999
        ENDIF      
	DO 10 I=1,M		
		READ(1,15) (H(I,J),J=1,N)  
  10	CONTINUE
  15	FORMAT(16F8.4)
C
C
	OPEN(2,FILE='angle.dat')
	READ(2,*) M2,N2,DX2,DY2
	IF(M2.NE.M.OR.N2.NE.N) THEN
           WRITE(*,*) ' Rerun REFRACT'
           GO TO 999
        ENDIF
	DO 30 I=1,M2		
		READ(2,35) (THETA(I,J),J=1,N2)
  30	CONTINUE
  35	FORMAT(16F8.4)	
C
C
C	WAVE HEIGHT AND ANGLE ARE USED TO COMPUTE X AND Y COMPONENTS
C	OF WAVE HEIGHT VECTOR
C	VECTOR COMPONENTS ARE REQUIRED AS INPUT FOR 
C	GRAPHICS SUBROUTINE 'VELVCT'
C	DATA ASSIGNED TO NEW PLOTTING LOCATIONS FOR PURPOSE OF
C	ROTATING THE PLOT BY 90 DEGREES SO SHORELINE IS AT THE 
C	BOTTOM OF THE PLOT
C
C
	DO 50 I=1,M
		DO 60 J=1,N
			U(I,J)=H(I,J)*COS(RAD*THETA(I,J))
			V(I,J)=H(I,J)*SIN(RAD*THETA(I,J))
  60		CONTINUE
  50	CONTINUE
C
C
        MP1=M+1
	DO 40 I=1,M
		DO 45 J=1,N
			U1(I,J)=U(I,J)
			V1(I,J)=V(I,J)
  45		CONTINUE
  40	CONTINUE
C
C
C	ONLY EVEN POINTS SAMPLED TO REDUCE M X M GRID TO M/2 X M/2 GRID
C	TO ENHANCE RESOLUTION OF THE PLOT
C
C
        WRITE(*,*) ' TYPE 1 IF YOU WANT TO REDUCE THE DATA SET'
        READ(*,*) ISWITCH
        IF(ISWITCH.EQ.1) then
  	  DO 70 I=2,M,2 
		DO 80 J=2,N,2
		 	K=I/2
			L=J/2
			U2(K,L)=U1(I,J)
			V2(K,L)=V1(I,J)
  80		CONTINUE
  70	  CONTINUE
          M=M/2
          N=N/2
C
C
	  CALL VELVCT(U2,imax,V2,jmax,M,N,0.0,0.0,0,0,0,0.0)
C
C
        ELSE
          CALL VELVCT(U1,imax,V1,jmax,M,N,0.0,0.0,0,0,0,0.0)
	ENDIF
	CALL GDAWK(1)
	CALL GCLWK(1)
	CALL GCLKS
        write(*,*) ' Hardcopy: ftrans -d ps.mono gmeta |lpr -Plw'
	write(*,*) '   screen: ctrans -d sunview gmeta'
  999   CONTINUE
	END
